Attribute VB_Name = "1"
Option Explicit

'     
Private Type mnuCommands
    Captions As New Collection
    Commands As New Collection
End Type
Public Type FileType
    Commands As mnuCommands
    Extension As String
    ProperName As String
    FullName As String
    ContentType As String
    IconPath As String
    IconIndex As Integer
End Type

'   
Public Enum REGToolKeyTypes
    REG_SZ = 1      '   
    REG_BINARY = 3  '   
    REG_DWORD = 4   ' 32-  
    REG_MULTI_SZ = 7 '       ,
                     '    
End Enum

'   
Public Enum REGToolRootTypes
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

Public Const ERROR_SUCCESS = 0&                 '    
                                                '   / 
Private Const KEY_WRITE = &H20006               '    
Private Const gsSLASH_BACKWARD As String = "\"  '   

'  API    
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal Reserved As Long, _
    ByVal lpClass As String, _
    ByVal dwOptions As Long, _
    ByVal samDesired As Long, _
    lpSecurityAttributes As SECURITY_ATTRIBUTES, _
    phkResult As Long, _
    lpdwDisposition As Long _
) As Long

'  API     
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    lpData As Any, _
    ByVal cbData As Long _
) As Long

'  API     
Private Declare Function RegCloseKey Lib "advapi32.dll" ( _
    ByVal hKey As Long _
) As Long

'   
Public Const g_FileExtension = ".ort"
Public Const g_FileTypeName = "   -2"
Public Const g_kQuote = """"

' -------------------------------------------------------------------
'         |
' -------------------------------------------------------------------
Public Sub CreateExtension(newfiletype As FileType)
Dim IconString As String
Dim CurrentKey As String
Dim CurrentCommand As String
Dim i As Long

    '     DefaultIcon
    IconString = newfiletype.IconPath & "," & newfiletype.IconIndex
    '     
    If Left$(newfiletype.Extension, 1) <> "." Then
        newfiletype.Extension = "." & newfiletype.Extension
    End If
    '   
    MsgBox "NAME=" & SetRegInfo(HKEY_CLASSES_ROOT, newfiletype.Extension, "", REG_SZ, _
                      ByVal newfiletype.ProperName)
    '    
    If newfiletype.ContentType <> "" Then
        MsgBox "NAME=" & SetRegInfo(HKEY_CLASSES_ROOT, newfiletype.Extension, "Content Type", REG_SZ, _
                   ByVal CStr(newfiletype.ContentType))
    End If
    '    
    MsgBox "EXT=" & SetRegInfo(HKEY_CLASSES_ROOT, newfiletype.ProperName, "", REG_SZ, _
               ByVal newfiletype.FullName)
    '   "ProperNameDefaultIcon"      
    '  
    If Not IconString = ",0" Then
        CurrentKey = newfiletype.ProperName & "\DefaultIcon"
        MsgBox "ICON=" & SetRegInfo(HKEY_CLASSES_ROOT, CurrentKey, "", REG_SZ, ByVal IconString)
    End If
    '         
    For i = 1 To newfiletype.Commands.Captions.Count
        CurrentKey = newfiletype.ProperName & "\Shell\" & _
                     newfiletype.Commands.Captions(i) & "\Command"
        CurrentCommand = newfiletype.Commands.Commands(i)
        MsgBox "COMMAND=" & SetRegInfo(HKEY_CLASSES_ROOT, CurrentKey, "", REG_SZ, ByVal CurrentCommand)
    Next i
End Sub


' ------------------------------------------
'       |
' ------------------------------------------
Private Function SetRegInfo( _
                            ByVal hKey As REGToolRootTypes, _
                            ByVal SubKey As String, _
                            ByVal ValueName As String, _
                            ByVal DataType As REGToolKeyTypes, _
                            ByVal InBuffer As Variant _
) As Boolean
' hKey      -    ,    
'              
' SubKey    -   ,      
'              .   ,  .
' ValueName -   ,      
'             ,   
' DataType  -    
' InBuffer  -         DataType

Dim secattr As SECURITY_ATTRIBUTES  '   ,  Win9x .
Dim hCurKey As Long                 '    
Dim lDisposition As Long            ' ,    
                                    '  REG_CREATED_NEW_KEY, REG_OPENED_EXISTING_KEY
Dim lRes As Long                    '    API
Dim sData As String                 '     InBuffer
Dim sLength As Long                 '      
                                    '    
Dim DWORDSymbol As String           '    DWORD
Dim DWORDBuffer As String           '     DWORD
Dim i As Integer                    '  

    On Error GoTo LocalError
    '   
    If Not ValidKeyName(SubKey) Then Exit Function
    '    
    secattr = SetAccess
    '       
    '   .
    lRes = RegCreateKeyEx(hKey, SubKey & vbNullChar, 0, "", 0, KEY_WRITE, _
                          secattr, hCurKey, lDisposition)
    If lRes = ERROR_SUCCESS Then
        Select Case DataType
            Case REG_SZ '      
                If VarType(InBuffer) = vbString Then
                    sData = CStr(InBuffer) & vbNullChar
                    sLength = Len(sData) - 1
                Else
                    Err.Number = 5
                    GoTo LocalError
                End If
            Case REG_BINARY '      
                If VarType(InBuffer) = vbByte Then
                    sLength = 1
                    InBuffer = Hex(CByte(InBuffer))
                    Do Until Len(InBuffer) = 2
                        InBuffer = "0" & InBuffer '    
                    Loop
                    DWORDSymbol = Chr(Format("&H" + InBuffer))
                    sData = DWORDSymbol
                Else
                    Err.Number = 5
                    GoTo LocalError
                End If
            Case REG_DWORD '   Double Word   
                If VarType(InBuffer) = vbLong Then
                    sLength = 4
                    InBuffer = Hex(InBuffer)
                    Do Until Len(InBuffer) = 8
                        InBuffer = "0" & InBuffer '    
                    Loop
                    For i = sLength To 1 Step -1
                        DWORDSymbol = Chr(Format("&H" + Mid$(InBuffer, (i * 2) - 1, 2)))
                        DWORDBuffer = DWORDBuffer + DWORDSymbol
                    Next i
                    sData = DWORDBuffer
                Else
                    Err.Number = 5
                    GoTo LocalError
                End If
        End Select
        ' hCurKey -   ,   
        '    sData   ,     ByVal.
        '     .
        lRes = RegSetValueEx(hCurKey, ValueName & vbNullChar, 0, DataType, _
                                 ByVal sData, sLength)
        If lRes <> ERROR_SUCCESS Then GoTo LocalError '  
        SetRegInfo = True
    Else
LocalError: '    = lRes
        If Err.Number > 0 Then Err.Raise Err.Number '  
    End If
    lRes = RegCloseKey(hCurKey) '   
End Function

' -------------------------------------------------------------
'        |
' -------------------------------------------------------------
Private Function ValidKeyName(KeyName As String) As Boolean
    '   ,      \  \\
    If Left$(KeyName, 1) <> gsSLASH_BACKWARD Then
        If Right$(KeyName, 1) <> gsSLASH_BACKWARD Then
            If InStr(KeyName, gsSLASH_BACKWARD & gsSLASH_BACKWARD) = 0 Then
                ValidKeyName = True
            End If
        End If
    End If
End Function

Sub main()
Dim myfiletype As FileType  '        
    
    '       
    With myfiletype
        .Commands.Captions.Add "Open"
        .Commands.Commands.Add g_kQuote & App.Path & "\" & App.EXEName & ".exe"" ""%1"""
        .Extension = g_FileExtension
        .ProperName = "File" & App.EXEName
        .FullName = g_FileTypeName
        .ContentType = "application/" & App.EXEName
        .IconPath = App.Path & "\" & App.EXEName & ".exe"
        .IconIndex = 1
    End With
    CreateExtension myfiletype
End Sub
